/*
This file is auto-generated by OWL2Go (https://git.rwth-aachen.de/acs/public/ontology/owl/owl2go).

Copyright 2020 Institute for Automation of Complex Power Systems,
E.ON Energy Research Center, RWTH Aachen University

This project is licensed under either of
- Apache License, Version 2.0
- MIT License
at your option.

Apache License, Version 2.0:

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

MIT License:

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/

package main

import (
	"fmt"
	"os"
	"strconv"
	"time"

	"git.rwth-aachen.de/acs/public/ontology/owl/owl2go/pkg/rdf"
	"git.rwth-aachen.de/acs/public/ontology/owl/saref/pkg/saref"
	"git.rwth-aachen.de/acs/public/ontology/owl/saref/test/input"
)

func main() {
	var err error
	// err = generateInputFiles()
	// if err != nil {
	// 	fmt.Println(err)
	// 	return
	// }

	var dDeser, dModGraph, dGraphMod, dSer time.Duration

	for i := 0; i < 5; i++ {
		var dtDeser, dtModGraph, dtGraphMod, dtSer time.Duration
		dtDeser, dtModGraph, dtGraphMod, dtSer, err = measurePerformance(10000)
		if err != nil {
			fmt.Println(err)
			return
		}
		dDeser += dtDeser
		dModGraph += dtModGraph
		dGraphMod += dtGraphMod
		dSer += dtSer
	}
	dDeser = dDeser / 5
	dModGraph = dModGraph / 5
	dGraphMod = dGraphMod / 5
	dSer = dSer / 5

	fmt.Println("Deserialization: ", dDeser, "Model from Graph: ", dModGraph, "Graph from Model: ", dGraphMod, "Serialization: ", dSer)
}

func generateInputFiles() (err error) {
	var file *os.File
	file, err = os.Create("input10.ttl")
	if err != nil {
		fmt.Println(err)
		return
	}
	err = input.GenerateInputFile(10, file)
	if err != nil {
		fmt.Println(err)
		return
	}
	err = file.Close()
	if err != nil {
		fmt.Println(err)
		return
	}

	file, err = os.Create("input100.ttl")
	if err != nil {
		fmt.Println(err)
		return
	}
	err = input.GenerateInputFile(100, file)
	if err != nil {
		fmt.Println(err)
		return
	}
	err = file.Close()
	if err != nil {
		fmt.Println(err)
		return
	}

	file, err = os.Create("input1000.ttl")
	if err != nil {
		fmt.Println(err)
		return
	}
	err = input.GenerateInputFile(1000, file)
	if err != nil {
		fmt.Println(err)
		return
	}
	err = file.Close()
	if err != nil {
		fmt.Println(err)
		return
	}

	file, err = os.Create("input10000.ttl")
	if err != nil {
		fmt.Println(err)
		return
	}
	err = input.GenerateInputFile(10000, file)
	if err != nil {
		fmt.Println(err)
		return
	}
	err = file.Close()
	if err != nil {
		fmt.Println(err)
		return
	}
	return
}

func measurePerformance(size int) (dDeser, dModGraph, dGraphMod, dSer time.Duration, err error) {
	var file *os.File
	var mod *saref.Model

	file, err = os.Open("input" + strconv.Itoa(size) + ".ttl")
	if err != nil {
		fmt.Println(err)
		return
	}

	tstart := time.Now()
	triples, err := rdf.DecodeTTL(file)
	if err != nil {
		return
	}
	err = file.Close()
	if err != nil {
		return
	}
	g, err := rdf.NewGraph(triples)
	if err != nil {
		return
	}
	dDeser = time.Since(tstart)
	// fmt.Println("Time for deserialization to graph: ", dDeser)

	tstart = time.Now()
	mod, err = saref.NewModelFromGraph(g)
	if err != nil {
		return
	}
	dModGraph = time.Since(tstart)
	// fmt.Println("Time for model creation from graph: ", dModGraph)

	file, err = os.Create("output.ttl")
	if err != nil {
		return
	}

	var gOut *rdf.Graph
	tstart = time.Now()
	gOut = mod.ToGraph()
	dGraphMod = time.Since(tstart)
	// fmt.Println("Time for graph creation from model: ", dGraphMod)

	tstart = time.Now()
	newTriples := gOut.ToTriples()
	err = rdf.EncodeTTL(newTriples, file)
	if err != nil {
		return
	}
	err = mod.ToTTL(file)
	if err != nil {
		return
	}
	dSer = time.Since(tstart)
	// fmt.Println("Time for serialization to ttl: ", dSer)

	err = file.Close()
	if err != nil {
		return
	}

	return
}
